
#include "unix.h"

typedef struct _Point {
    float x, y, z;
} Point;


Truncated_octahedron()
{
    FILE *fp;
    extern char *filename;
    extern char creatingObject;
    creatingObject = 0;

    filename = (char *) malloc( strlen((const char *)getenv("OBJ_PATH")) + 30 );
    strcat( strcat( strcpy( filename, (const char *)getenv("OBJ_PATH") ), "/" ), "truncated_octahedron.geom" );
    fp = fopen( filename, "w" );

    fprintf( fp, "28\t14\t76\n" );

    /* Print the Coordinates of the points */
    fprintf( fp, "0 0.447214 0.894427\n" );
    fprintf( fp, "0.447214 0 0.894427\n" );
    fprintf( fp, "0 -0.447214 0.894427\n" );
    fprintf( fp, "0.447214 0.894427 0\n" );
    fprintf( fp, "0 0.894427 0.447214\n" );
    fprintf( fp, "-0.223607 0.223607 -0.894427\n" );
    fprintf( fp, "-0.447214 0.894427 0\n" );
    fprintf( fp, "0 0.894427 -0.447214\n" );
    fprintf( fp, "-0.447214 0 -0.894427\n" );
    fprintf( fp, "0 -0.447214 -0.894427\n" );
    fprintf( fp, "-0.894427 0.447214 0\n" );
    fprintf( fp, "-0.447214 0 0.894427\n" );
    fprintf( fp, "-0.223607 -0.223607 0.894427\n" );
    fprintf( fp, "-0.894427 -0.447214 0\n" );
    fprintf( fp, "-0.894427 -0.223607 -0.223607\n" );
    fprintf( fp, "-0.894427 0 -0.447214\n" );
    fprintf( fp, "-0.447214 -0.894427 0\n" );
    fprintf( fp, "0.894427 0.447214 0\n" );
    fprintf( fp, "-0.894427 0 0.447214\n" );
    fprintf( fp, "0 -0.894427 0.447214\n" );
    fprintf( fp, "0.447214 0 -0.894427\n" );
    fprintf( fp, "0.894427 0 0.447214\n" );
    fprintf( fp, "0.447214 -0.894427 0\n" );
    fprintf( fp, "0 0.447214 -0.894427\n" );
    fprintf( fp, "0.894427 0 -0.447214\n" );
    fprintf( fp, "0.894427 -0.447214 0\n" );
    fprintf( fp, "0.894427 -0.223607 -0.223607\n" );
    fprintf( fp, "0 -0.894427 -0.447214\n" );

    /* Print the Conectivity data of the points */
    fprintf( fp, "6 6 10 18 11 0 4\n" );
    fprintf( fp, "4 4 3 7 6\n" );
    fprintf( fp, "6 4 0 1 21 17 3\n" );
    fprintf( fp, "7 23 5 8 15 10 6 7\n" );
    fprintf( fp, "4 15 13 18 10\n" );
    fprintf( fp, "4 2 1 0 11\n" );
    fprintf( fp, "7 16 19 2 12 11 18 13\n" );
    fprintf( fp, "6 1 2 19 22 25 21\n" );
    fprintf( fp, "4 22 19 16 27\n" );
    fprintf( fp, "6 23 7 3 17 24 20\n" );
    fprintf( fp, "4 20 9 8 23\n" );
    fprintf( fp, "4 17 21 25 24\n" );
    fprintf( fp, "7 26 25 22 27 9 20 24\n" );
    fprintf( fp, "7 13 14 15 8 9 27 16\n" );

    fclose( fp );

    filename = (char *) malloc( strlen((const char *)getenv("OBJ_PATH")) + 20 );
    strcat( strcat( strcpy( filename, (const char *)getenv("OBJ_PATH") ), "/" ), "truncated_octahedron.aoff" );
    fp = fopen( filename, "w" );

    fprintf( fp, "geometry\tindexed_poly\tfff\t\t%s\n", "truncated_octahedron.geom" );
    fprintf( fp, "connect_offset\tdefault\t\tf\t\t0\n" );

    fclose( fp );
}
